# Meta Clustering Codes
Authors: Chenglong Ye, Jie Ding

## Installation of Python environment

Install Python and Pip (a Python-management tool)
Run the following in a terminal
```sh
 pip3 install --user virtualenv
```
The above will install a tool that allows us to create a virtual environment for running our python package

Then, cd into the project folder and install virtual env there 
```sh
 cd /Users/...
 python3 -m virtualenv venv
```
The above will create a virtual environment called venv

Finally, activate it by running
```sh
 source venv/bin/activate
```
check the Python version by running
```sh
 which python3
```

## Install necessary packages
In the terminal, stay on the path of the downloaded folder, and run
```sh
 pip3 install -r requirements.txt
```

## Reproduce each experiment
Run each experiment script by
```sh
 python3 experiments_[Name].py
```
The folder contains the following experiment files

1. experiments_accuracy.py     (Simulation 1: clustering accuracy)

2. experiments_robust.py       (Simulation 2: robustness against candidate models in the cross validation)

3. experiments_CTscan.py       (Application 1: more accurate prediction in CT Image data)

4. experiments_EGS.py          (Application 2: robust learning in Electrical Grid Stability data against adversaries)            

5. experiments_fairness.py     (Application to Data Fairness)


## License

MIT
